"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var generators_1 = require("../../tools/generators");
var pretty_1 = require("../../tools/pretty");
module.exports = {
    alias: ["splash"],
    description: "Generates splash-screen from templates",
    run: function (toolbox) { return __awaiter(void 0, void 0, void 0, function () {
        var generator;
        var _a;
        return __generator(this, function (_b) {
            generator = (_a = toolbox.parameters.command) === null || _a === void 0 ? void 0 : _a.toLowerCase();
            (0, generators_1.runGenerator)(toolbox, generate, generator);
            return [2 /*return*/];
        });
    }); },
};
function generate(toolbox) {
    return __awaiter(this, void 0, void 0, function () {
        var parameters, generator, backgroundColor, _a, _b, androidSize, _c, iosSize, options, _d, isValid, messages, isSuccessful;
        return __generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    parameters = toolbox.parameters;
                    generator = parameters.command.toLowerCase();
                    backgroundColor = parameters.first;
                    _a = parameters.options || {}, _b = _a.androidSize, androidSize = _b === void 0 ? 180 : _b, _c = _a.iosSize, iosSize = _c === void 0 ? 212 : _c, options = __rest(_a, ["androidSize", "iosSize"]);
                    if (!backgroundColor) {
                        (0, pretty_1.warning)("\u26A0\uFE0F  Please specify the background color of the screen that will be used to generate the splash screen.");
                        (0, pretty_1.p)();
                        (0, pretty_1.command)("npx ignite-cli g ".concat(generator, " \"#191015\" [--android-size=180 --ios-size=212]"));
                        return [2 /*return*/];
                    }
                    // force coercion of size to number if a user quotes it
                    // force coercion of background to string if the hex color is numerical; add "#" if it's not there
                    androidSize = Number(androidSize);
                    iosSize = Number(iosSize);
                    backgroundColor = String(backgroundColor).startsWith("#")
                        ? backgroundColor
                        : "#".concat(backgroundColor);
                    return [4 /*yield*/, (0, generators_1.validateSplashScreenGenerator)({ androidSize: androidSize, iosSize: iosSize, backgroundColor: backgroundColor }, options)];
                case 1:
                    _d = _e.sent(), isValid = _d.isValid, messages = _d.messages;
                    if (!isValid) {
                        messages.forEach(function (message) { return (0, pretty_1.warning)(message); });
                        return [2 /*return*/];
                    }
                    return [4 /*yield*/, (0, generators_1.generateSplashScreen)({ androidSize: androidSize, iosSize: iosSize, backgroundColor: backgroundColor })];
                case 2:
                    isSuccessful = _e.sent();
                    if (isSuccessful) {
                        (0, pretty_1.heading)("Splash screen generated!");
                        (0, pretty_1.p)("Uninstall the application from your simulator/emulator and re-build your app to see the changes!");
                        (0, pretty_1.p)("Note: (vanilla Android) The splash-screen will not appear if you launch your app via the terminal or Android Studio. Kill the app and launch it normally by tapping on the launcher icon. https://stackoverflow.com/a/69831106");
                        (0, pretty_1.p)("Note: (vanilla iOS) You might notice the splash-screen logo change size. This happens in debug/development mode. Try building the app for release.");
                    }
                    return [2 /*return*/];
            }
        });
    });
}
//# sourceMappingURL=splash-screen.js.map