"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var pretty_1 = require("../tools/pretty");
var strip_ansi_1 = require("../tools/strip-ansi");
var isMac = process.platform === "darwin";
var START_CMD = isMac ? "open" : "start";
module.exports = {
    alias: ["i"],
    description: "Opens a new GitHub issue for Ignite.",
    run: function (toolbox) {
        return __awaiter(this, void 0, void 0, function () {
            var filesystem, system, colors, parameters, prompt, yellow, cyan, title, suggestedTitle_1, titleResponse, doctorInfo, IGNITE, doctorANSI, e_1, header, body, url, params, e_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        filesystem = toolbox.filesystem, system = toolbox.system, colors = toolbox.print.colors, parameters = toolbox.parameters, prompt = toolbox.prompt;
                        yellow = colors.yellow, cyan = colors.cyan;
                        title = parameters.first;
                        if (!title) {
                            (0, pretty_1.warning)("\u26A0\uFE0F  Please specify a title for your issue:");
                            (0, pretty_1.p)();
                            (0, pretty_1.command)("ignite i \"The issue title here\"");
                            return [2 /*return*/];
                        }
                        if (!(parameters.array.length > 1 && !parameters.first.startsWith('"'))) return [3 /*break*/, 2];
                        suggestedTitle_1 = parameters.array.join(" ");
                        return [4 /*yield*/, prompt.ask(function () { return ({
                                type: "confirm",
                                name: "title",
                                message: "Received title \"".concat(title, "\" but without quotes, did you mean \"").concat(suggestedTitle_1, "\"?"),
                                initial: true,
                                format: pretty_1.prettyPrompt.format.boolean,
                                prefix: pretty_1.prefix,
                            }); })];
                    case 1:
                        titleResponse = _a.sent();
                        if (titleResponse.title) {
                            title = suggestedTitle_1;
                        }
                        _a.label = 2;
                    case 2:
                        doctorInfo = "";
                        (0, pretty_1.startSpinner)(" Gathering system and project details");
                        _a.label = 3;
                    case 3:
                        _a.trys.push([3, 5, , 6]);
                        IGNITE = "node " + filesystem.path(__dirname, "..", "..", "bin", "ignite");
                        return [4 /*yield*/, system.run("".concat(IGNITE, " doctor"))];
                    case 4:
                        doctorANSI = _a.sent();
                        doctorInfo = (0, strip_ansi_1.stripANSI)(doctorANSI);
                        return [3 /*break*/, 6];
                    case 5:
                        e_1 = _a.sent();
                        (0, pretty_1.p)(yellow("Unable to gather system and project details."));
                        return [3 /*break*/, 6];
                    case 6:
                        (0, pretty_1.stopSpinner)(" Gathering system and project details", "🛠️");
                        header = "\n### Describe the bug\n\n<!--\uD83D\uDEA8\uD83D\uDEA8\uD83D\uDEA8 Fill out bug description here, please provide reproducible steps, repo/code snippets and any other helpful information if available! \uD83D\uDEA8\uD83D\uDEA8\uD83D\uDEA8-->\n\n### Additional info\nnpx ignite-cli doctor";
                        body = "".concat(header, "\n\n```\n").concat(doctorInfo, "```");
                        url = new URL("https://github.com/infinitered/ignite/issues/new");
                        params = new URLSearchParams(url.search);
                        params.append("title", title);
                        params.append("body", body);
                        _a.label = 7;
                    case 7:
                        _a.trys.push([7, 9, , 10]);
                        (0, pretty_1.p)(cyan("Starting GitHub issue, thanks for alerting us!"));
                        return [4 /*yield*/, system.run("".concat(START_CMD, " \"").concat(url, "?").concat(params.toString(), "\""))];
                    case 8:
                        _a.sent();
                        return [3 /*break*/, 10];
                    case 9:
                        e_2 = _a.sent();
                        (0, pretty_1.p)(yellow("Unable to start GitHub issue."));
                        return [3 /*break*/, 10];
                    case 10:
                        process.exit(0);
                        return [2 /*return*/];
                }
            });
        });
    },
};
//# sourceMappingURL=issue.js.map