"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var demo_1 = require("../tools/demo");
var flag_1 = require("../tools/flag");
var pretty_1 = require("../tools/pretty");
module.exports = {
    alias: ["rdm"],
    description: "Remove all demo markup from generated boilerplate. Add --dry-run to see what would be removed.",
    run: function (toolbox) { return __awaiter(void 0, void 0, void 0, function () {
        var parameters, system, CWD, TARGET_DIR, dryRun, filePaths, demoCommentResults;
        var _a, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    parameters = toolbox.parameters, system = toolbox.system;
                    CWD = process.cwd();
                    TARGET_DIR = (_a = parameters.first) !== null && _a !== void 0 ? _a : CWD;
                    dryRun = (_b = (0, flag_1.boolFlag)(parameters.options.dryRun)) !== null && _b !== void 0 ? _b : false;
                    (0, pretty_1.p)();
                    (0, pretty_1.p)("Removing demo markup from '".concat(TARGET_DIR, "'").concat(dryRun ? " (dry run)" : ""));
                    filePaths = demo_1.demo.find(TARGET_DIR);
                    return [4 /*yield*/, demo_1.demo.update({ filePaths: filePaths, dryRun: dryRun, onlyMarkup: true })
                        // Handle the results of the demo comment operations
                    ];
                case 1:
                    demoCommentResults = _c.sent();
                    // Handle the results of the demo comment operations
                    demoCommentResults
                        // Sort the results by the path in alphabetical order
                        .sort(function (a, b) {
                        if (a.status === "fulfilled" && b.status === "fulfilled") {
                            return a.value.path.localeCompare(b.value.path);
                        }
                        return 0;
                    })
                        .forEach(function (result) {
                        // Log any rejected results as warnings
                        if (result.status === "rejected") {
                            (0, pretty_1.warning)(result.reason);
                            return;
                        }
                        // Log any fulfilled results that have comments
                        var _a = result.value, path = _a.path, comments = _a.comments;
                        if (comments.length > 0) {
                            (0, pretty_1.p)("Found ".concat(comments.map(function (c) { return "'".concat(c, "'"); }).join(", "), " in ").concat(path));
                        }
                    });
                    if (!!dryRun) return [3 /*break*/, 3];
                    return [4 /*yield*/, system.run("npx prettier@2.8.1 --write \"./app/**/*.{js,jsx,json,md,ts,tsx}\"", {
                            trim: true,
                        })];
                case 2:
                    _c.sent();
                    _c.label = 3;
                case 3:
                    (0, pretty_1.p)("Done removing demo markup from '".concat(TARGET_DIR, "'").concat(dryRun ? " (dry run)" : ""));
                    return [2 /*return*/];
            }
        });
    }); },
};
//# sourceMappingURL=remove-demo-markup.js.map