"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var pretty_1 = require("../tools/pretty");
var react_native_1 = require("../tools/react-native");
module.exports = {
    alias: ["rn"],
    description: "Renames a React Native and/or Ignite app",
    run: function (toolbox) { return __awaiter(void 0, void 0, void 0, function () {
        var parameters, prompt, filesystem, print, colors, info, red, green, newName, newBundleIdentifier, appJsonPath, appJson, oldName, oldBundleIdentifier, result, result;
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    parameters = toolbox.parameters, prompt = toolbox.prompt, filesystem = toolbox.filesystem, print = toolbox.print;
                    colors = print.colors, info = print.info;
                    red = colors.red, green = colors.green;
                    newName = parameters.first;
                    newBundleIdentifier = parameters.options.bundle;
                    appJsonPath = "".concat(process.cwd(), "/app.json");
                    // first check if we are in the folder with the app.json file
                    if (!filesystem.exists(appJsonPath)) {
                        (0, pretty_1.warning)("You must be in the root of a React Native project to rename it.");
                        (0, pretty_1.warning)("(We look for an app.json file to verify this.)");
                        return [2 /*return*/];
                    }
                    appJson = require(appJsonPath);
                    oldName = appJson.name;
                    if (!oldName) {
                        (0, pretty_1.warning)("Couldn't find the current name in app.json.");
                        return [2 /*return*/];
                    }
                    oldBundleIdentifier = (_a = appJson.expo.android.package) !== null && _a !== void 0 ? _a : appJson.expo.ios.bundleIdentifier;
                    if (!oldBundleIdentifier) {
                        (0, pretty_1.warning)("Couldn't find the current name in app.json.");
                        return [2 /*return*/];
                    }
                    if (!!newName) return [3 /*break*/, 2];
                    return [4 /*yield*/, prompt.ask({
                            type: "input",
                            name: "newName",
                            message: "What would you like to rename your app to? Currently: ".concat(oldName),
                        })];
                case 1:
                    result = _b.sent();
                    newName = result.newName;
                    _b.label = 2;
                case 2:
                    if (!newName) {
                        // no name, no go
                        (0, pretty_1.warning)("No name provided, nothing to do.");
                        return [2 /*return*/];
                    }
                    if (!!newBundleIdentifier) return [3 /*break*/, 4];
                    return [4 /*yield*/, prompt.ask({
                            type: "input",
                            name: "newBundleIdentifier",
                            message: "What would you like to rename your package to? Currently: ".concat(oldBundleIdentifier),
                        })];
                case 3:
                    result = _b.sent();
                    newBundleIdentifier = result.newBundleIdentifier;
                    _b.label = 4;
                case 4:
                    if (!newBundleIdentifier) {
                        // no name, no go
                        (0, pretty_1.warning)("No package name provided, nothing to do.");
                        return [2 /*return*/];
                    }
                    // rename the app
                    if (oldName === newName) {
                        (0, pretty_1.warning)("The current name and the new name are the same.");
                        return [2 /*return*/];
                    }
                    return [4 /*yield*/, (0, react_native_1.renameReactNativeApp)(toolbox, oldName, newName, oldBundleIdentifier, newBundleIdentifier)];
                case 5:
                    _b.sent();
                    (0, pretty_1.heading)("Ignite successfully renamed your app from ".concat(red(oldName), " to ").concat(green(newName), "!"));
                    (0, pretty_1.p)();
                    (0, pretty_1.heading)("Caveats:");
                    (0, pretty_1.p)();
                    info("    * Ignite's rename feature is not 100% perfect in all cases.");
                    info("      Carefully examine the diff it produces with `git diff` before committing.");
                    info("    * Additionally, you'll want to re-run `pod install` and");
                    info("      rebuild your app and caches. We don't make any changes to those files or folders.");
                    (0, pretty_1.p)();
                    (0, pretty_1.direction)("Next: run `git diff` to see the changes we made.");
                    (0, pretty_1.direction)("To reset everything: run `git reset --hard && git clean -fd`");
                    (0, pretty_1.warning)("(".concat(red("careful"), ": this will remove all other changes you haven't committed!)"));
                    return [2 /*return*/];
            }
        });
    }); },
};
//# sourceMappingURL=rename.js.map