"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var gluegun_1 = require("gluegun");
var packager_1 = require("../tools/packager");
module.exports = {
    alias: ["s"],
    description: "Snackify Ignite app",
    run: function (toolbox) { return __awaiter(void 0, void 0, void 0, function () {
        var print, prompt, system, patching, remove, exists, info, gitExists, getStatus, branchName, confirm, removeArray, addPackages, removePackages;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    print = toolbox.print, prompt = toolbox.prompt, system = toolbox.system, patching = toolbox.patching;
                    remove = gluegun_1.filesystem.remove, exists = gluegun_1.filesystem.exists;
                    info = print.info;
                    gitExists = exists("./.git");
                    if (!(gitExists === "dir")) return [3 /*break*/, 4];
                    return [4 /*yield*/, system.run("git status -s")];
                case 1:
                    getStatus = _a.sent();
                    if (!(getStatus === "")) return [3 /*break*/, 3];
                    return [4 /*yield*/, system.run("git branch --show-current")];
                case 2:
                    branchName = _a.sent();
                    if (!branchName.includes("snack")) {
                        info("Creating a new branch for your snack");
                        system.run("git checkout -b snack-$(date +'%m%d%y')");
                    }
                    return [3 /*break*/, 4];
                case 3:
                    info("There are uncommitted changes in your current branch, please commit changes before running this");
                    return [2 /*return*/];
                case 4:
                    info("This command will create an Expo snack project for you. ");
                    info("This can be exported to an Expo snack for you to test and play with your app.");
                    info("In order to snackify (create an Expo snack) this project, we must delete:");
                    info("- /ios\n- /android\n- /e2e\n- /test\n- /app/services/reactotron\n- jest.config.js\n- metro.config.js\n- webpack.config.js");
                    return [4 /*yield*/, prompt.confirm("Do you wish to continue", true)
                        // the following array contains folders and files that are deleted to make project ready for some snacking
                    ];
                case 5:
                    confirm = _a.sent();
                    removeArray = [
                        "./ios",
                        "./android",
                        "./e2e",
                        "./test",
                        "./jest.config.js",
                        "./metro.config.js",
                        "./webpack.config.js",
                        "./app/services/reactotron",
                    ];
                    if (!confirm) return [3 /*break*/, 8];
                    // 1. delete all folders and files that are not required
                    removeArray.map(function (val) { return remove(val); });
                    // 2. Create a new file to handle reactotron
                    gluegun_1.filesystem.file("./app/services/reactotron/index.ts");
                    patching.replace("./app/services/reactotron/index.ts", "", "/*** This file is loaded for snack to resolve Reactotron for expo snack**/ \n export const setupReactotron = (arg1:any) => null \nexport const setReactotronRootStore=(arg1:any, arg2:any)=>null");
                    addPackages = [
                        "expo-constants@~13.2.4",
                        "expo-localization@~13.1.0",
                        "expo-modules-core@~0.11.4",
                        "expo-splash-screen@~0.16.2",
                        "react-native-screens@~3.15.0",
                        "@react-native-async-storage/async-storage@~1.17.3",
                    ];
                    removePackages = [
                        "@expo/webpack-config",
                        "reactotron-react-native",
                        "ts-jest",
                        "jest",
                        "metro-config",
                        "@rnx-kit/metro-config",
                        "reactotron-mst",
                        "reactotron-react-js",
                        "reactotron-core-client",
                    ];
                    return [4 /*yield*/, packager_1.packager.add(addPackages.join(" "))];
                case 6:
                    _a.sent();
                    return [4 /*yield*/, packager_1.packager.remove(removePackages.join(" "))];
                case 7:
                    _a.sent();
                    _a.label = 8;
                case 8:
                    info("All done, your app is ready to be imported into Expo snack");
                    info("The best way to import this project into an Expo snack is via publishing this project into a public repository on github and then adding your repo's URL to an expo snack - https://snack.expo.dev/");
                    return [2 /*return*/];
            }
        });
    }); },
};
//# sourceMappingURL=snackify.js.map